//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben 		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

#include <device.h>

//Routinen zum ansteuern der Netzwerkkarte 

// Schreibt ein Byte in ein angegebenes Register der Netzwerkkarte
void WriteRTL (char RTLADDR,char RTLDATA)
{
	char a = 0;
	//Der Datenport wir auf output gesetzt vom C zum NIC schreiben
	DATA_CTRL_RLT = OUTPUT;
	//write Adress to Port
	ADDR_PORT_RLT = (96 + RTLADDR);
	//write Data to Port
	DATA_PORT_RLT_WRITE = RTLDATA;
	//set write Pin to Low
	cbi (ADDR_PORT_RLT,WRITE_PIN);
	//wait a short time
	while (a < 100)
	{
	a++;
	}
	//set write Pin to High
	sbi (ADDR_PORT_RLT,WRITE_PIN);	
	//write to RTL complete
}


// Auslesen eines Byte von einen angegebenes Register der Netzwerkkarte
unsigned char ReadRTL (char rtl_addr)
{
	unsigned char a = 0;
	unsigned char rtl_data;
	//Der Datenport wir auf input gesetzt vom NIC zum C lesen
	DATA_CTRL_RLT = INPUT;
	//write Adress to Port
	ADDR_PORT_RLT = (96 + rtl_addr);
	//set read Pin to Low
	cbi (ADDR_PORT_RLT , READ_PIN);
	//wait a short time	
	while (a < 100)
	{
	a++;
	}
	//read from port rtldata
	rtl_data = DATA_PORT_RLT_READ;	
	//set Read Pin to High
	sbi (ADDR_PORT_RLT , READ_PIN);	
	//read from RTL complete
	return (rtl_data);
}

//Hier wird die Netzwerkkarte Grundinizialisiert
void Init_Realtek_Network_Card (void)
{
#if defined (__AVR_ATmega128__)
	//Set Addr Port Direction = Output
	DATA_ADDR_RLT = OUTPUT;
#endif

#if defined (__AVR_ATmega32__)
	//Set Addr Port Direction = Output
	DATA_ADDR_RLT = OUTPUT;
#endif

	//Set all Addrport High
	ADDR_PORT_RLT = 255;
	//set Data Port Direction = Input
	DATA_CTRL_RLT = INPUT;


	printf ("\n\n\n\nInit Network Card: ");

	//Set Reset Pin Low
	cbi (ADDR_PORT_RLT , RESET_PIN);		
	
	ReadRTL (RSTPORT);
	WriteRTL (RSTPORT , 0xFF);
	
	//wait a schort time
	int a = 0;
	while (a < 1000)
	{
	a++;
	}
	
	printf (".");			//Point 1
	WriteRTL (CR , 0x21);

	//wait a schort time
	a = 0;
	while (a < 1000)
	{
	a++;
	}
	
	printf (".");			//Point 2
	WriteRTL (DCR , DCRVAL);
	WriteRTL (RBCR0 , 0x00);
	WriteRTL (RBCR1 , 0x00);
	WriteRTL (RCR , 0x04);
	WriteRTL (TPSR , RXSTART);
	WriteRTL (TCR , 0x02);
	WriteRTL (PSTART , RXSTART);
	WriteRTL (BNRY , RXSTART);
	WriteRTL (PSTOP , RXSTOP);
	WriteRTL (CR , 0x61);

	//wait a schort time	
	for (int a = 0; a < 1000; a++)
		{
		}

	printf (".");			//Point 3
	WriteRTL (CURR , RXSTART);
	
	for(int a = 0; a<=5; a++)
		{
		WriteRTL ((PAR0 + a) , mymac[a]);
		printf (".");		//Point 4,5,6,7,8,9
		}

	WriteRTL (CR , 0x21);
	WriteRTL (DCR , DCRVAL);
	WriteRTL (CR , 0x22);
	WriteRTL (ISR , 0xFF);
	WriteRTL (IMR , IMRVAL);
	WriteRTL (TCR , TCRVAL);
	printf (" Init Ready! \n");
}


void Write_Ethernet_Frame (char *buffer,unsigned int bufferlen)
{
	if (bufferlen < 0x40)
		{
		for (int a = (bufferlen-4);a <= 0x44;a++)
			{
			buffer[a] = 0x20;
			}
		bufferlen = 0x40;
		}
		
	WriteRTL (CR,0x22);
	WriteRTL (TPSR,TXSTART);
	WriteRTL (RSAR0,0x00);
	WriteRTL (RSAR1,0x40);
	WriteRTL (ISR,0xFF);
	WriteRTL (RBCR0,(bufferlen & 0x00ff) - 4);
	WriteRTL (RBCR1,(bufferlen & 0xff00) >>8);
	WriteRTL (CR,0x12);

	for (int a = 0; a < (bufferlen - 4);a++)
		{
		WriteRTL (RDMAPORT,buffer[a]);
		}
	
	//loop_until_bit_is_set(ReadRTL(isr),rdc);
	while ((ReadRTL(ISR)&(1<<RDC)) == 0) {}

	WriteRTL (TBCR0,(bufferlen & 0x00ff) - 4);
	WriteRTL (TBCR1,(bufferlen & 0xff00) >>8);
	WriteRTL (CR,0x24);
}

void Read_Ethernet_Frame (char *buffer,unsigned int *bufferlen)
{
	unsigned char byte = 0;
	unsigned int tmp1;

	WriteRTL(0x00 , 0x1A);	
	ReadRTL(0x10);
	ReadRTL(0x10);
	tmp1 = ReadRTL(0x10);
	*bufferlen = (ReadRTL(0x10)<<8)+tmp1;
	  
	for (int a = 0; a <= *bufferlen; a++)
		{
		if (a <= 1500)
			{
			byte = ReadRTL (0x10);
			buffer[a] = byte;
			}
			else
			{
			byte = ReadRTL (0x10);
			}
		}	
	tmp1 = byte & RDC;
	
	if ( tmp1 != 64 )
		{
		ReadRTL(0x07);
		}
}

